<?php

require_once(_PS_MODULE_DIR_ . 'orderipaddressverification/PrestoChangeoClasses/init.php');

class OrderIPAddressVerification extends PrestoChangeoModule
{
 	private $_html = '';
	public $_ov_key;
	public $_ov_cache;
 	protected $_full_version = 11000;
	
	public function __construct()
	{
		$this->name = 'orderipaddressverification';
		$this->tab = $this->getPSV()<1.4?'Presto-Changeo':'administration';
		if ($this->getPSV() >= 1.4)
			$this->author = 'Presto-Changeo';
        $this->version = '1.1';
	 	parent::__construct();
		if ($this->getPSV() >= 1.6)
			$this->bootstrap = true;		
	 	$this->_refreshProperties();
	 	$this->displayName = $this->l('Order IP Address Verification');
		$this->description = $this->l('Uses the user\'s IP Address to resolve their location (Country / City / Latitude & Longitude)');
		if ($this->upgradeCheck('OAV'))
			$this->warning = $this->l('We have released a new version of the module,') .' '.$this->l('request an upgrade at ').' https://www.presto-changeo.com/en/contact_us';
	}

   	public function install()
   	{
		if (!parent::install() || !$this->registerHook('adminorder') || !$this->registerHook('cart'))
			return false;
		Configuration::updateValue('OV_KEY', '');
		Configuration::updateValue('OV_CACHE', '30');
		Configuration::updateValue('PRESTO_CHANGEO_UC',time());			
		$query = 'CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.'oav_order_ip_log` (
  			`id_cart` INT NOT NULL ,
			`ip` VARCHAR( 30 ) NOT NULL ,
			PRIMARY KEY ( `id_cart` )
			) ENGINE=MyISAM DEFAULT CHARSET=utf8;';
		Db::getInstance()->Execute(trim($query));
		$query = 'CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.'oav_ip_info` (
			`ip` varchar(30) NOT NULL,
			`info` text NOT NULL,
			`lastdate` int(11) NOT NULL,
			PRIMARY KEY (`ip`)
			) ENGINE=MyISAM DEFAULT CHARSET=utf8;';		
		Db::getInstance()->Execute(trim($query));
		return true;
	}

	public function uninstall()
	{
		return parent::uninstall();
	}
	
	private function _refreshProperties()
	{
		$this->_ov_key = Configuration::get('OV_KEY');
		$this->_ov_cache = (int)Configuration::get('OV_CACHE');
		$this->_last_updated = Configuration::get('PRESTO_CHANGEO_UC');
	}

	public function getContent()
	{
		$this->_postProcess();
		$this->_displayForm();
		return $this->_html;
	}

    private function _displayForm()
    {
		$ps_version  = $this->getPSV();
		$this->_html = ($ps_version >= 1.5?'<div '.($ps_version < 1.6 ? 'style="width:900px;margin:auto"' : '').'  >':'').$this->getModuleRecommendations('OAV').'<h2 style="clear:both;padding-top:5px;">'.$this->displayName.' '.$this->version.'</h2>';
		if ($url = $this->upgradeCheck('OAV'))
			$this->_html .= '
			'.($ps_version < 1.6 ? '<fieldset class="width3" style="background-color:#FFFAC6;width:800px;">' : '<div class="panel">' ).'
				
				'.($ps_version < 1.6? '<legend>' : '<h3>').'
					<img src="'.$this->_path.'logo.gif" />'.$this->l('New Version Available').'
				'.($ps_version < 1.6? '</legend>' : '</h3>' ).'
			'.$this->l('We have released a new version of the module. For a list of new features, improvements and bug fixes, view the ').'<a href="'.$url.'" target="_index"><b><u>'.$this->l('Change Log').'</b></u></a> '.$this->l('on our site.').'
			<br />
			'.$this->l('For real-time alerts about module updates, be sure to join us on our') .' <a href="http://www.facebook.com/pages/Presto-Changeo/333091712684" target="_index"><u><b>Facebook</b></u></a> / <a href="http://twitter.com/prestochangeo1" target="_index"><u><b>Twitter</b></u></a> '.$this->l('pages').'.
			<br />
			<br />
			'.$this->l('Please').' <a href="https://www.presto-changeo.com/en/contact_us" target="_index"><b><u>'.$this->l('contact us').'</u></b></a> '.$this->l('to request an upgrade to the latest version').'.
			'.($ps_version < 1.6? '</fieldset>' : '</div>' ).'
			<br />';
        $this->_html .= '
			<link type="text/css" rel="stylesheet" href="'.$this->_path.'css/admin.css" />
			
			<style>
				.tooltipster-icon{
					display:inline-block;
					width:16px;
					height:16px;
					background:url('._MODULE_DIR_.$this->name.'/img/qm.png) no-repeat;
				}
			</style>
			'.($ps_version >= 1.5 ? ' 				
				<link type="text/css" rel="stylesheet" href="'.$this->_path.'css/tooltipster.css" />
				<script type="text/javascript" src="'.($this->_path).'css/jquery.tooltipster.min.js"></script>
				
			
			' : '
				<link rel="stylesheet" type="text/css" href="'._MODULE_DIR_.$this->name.'/css/tooltipster.css" />
				<link rel="stylesheet" type="text/css" href="'._MODULE_DIR_.$this->name.'/css/jquery-ui-1.10.4.custom.min.css" />
				<script type="text/javascript" src="'._MODULE_DIR_.$this->name.'/css/jquery.tooltipster.min.js"></script>'
			) .'
			
			<form action="'.$_SERVER['REQUEST_URI'].'" name="filter_form" method="post">
		
			'.($ps_version < 1.6 ? '	<fieldset style="width:800px;" class="width3">' : '<div class="panel">' ).'
				'.($ps_version < 1.6 ? '<legend>' : '<h3>').'
					<img src="../modules/'.$this->name.'/logo.gif" /> '.$this->l('Installation Instructions').'
				'.($ps_version < 1.6 ? '</legend>' : '</h3>' ).'
				<p>
					<b>1)</b> '.$this->l('Sign up for a free account at').' <b><a href="http://www.ipinfodb.com/register.php" target="_index">http://www.ipinfodb.com/register.php</a></b>.
					 					
					


					<span  class="info_tooltip" title=" <img src=\''.$this->_path.'img/activate.jpg\' width=400  border=\'0\' /> "> </span>
							
					'.$this->l('Your Server\'s IP Address is').' <b>'.$_SERVER['SERVER_ADDR'].'</b>
				</p>
				<p>
					<b>2)</b> '.$this->l('Open the "Activation Email" you get, and click on the link to activate your free account').'.
 					
					<span  class="info_tooltip" title=" <img src=\''.$this->_path.'img/activate.jpg\' width=400  border=\'0\' /> "> </span>
						
				</p>
				<p>
					<b>3)</b> '.$this->l('Copy your API Key and paste it in the settings section below').'.
 					
					<span  class="info_tooltip" title=" <img src=\''.$this->_path.'img/apikey.jpg\' width=400  border=\'0\' /> "> </span>
						
				</p>
			'.($ps_version < 1.6 ? '</fieldset>' : '</div>' ).'
			<br />
			
			'.($ps_version < 1.6 ? '<fieldset style="width:800px;" class="width3">' : '<div class="panel">' ).'
				'.($ps_version < 1.6 ? '<legend>' : '<h3>').'
				<img src="../modules/'.$this->name.'/logo.gif" /> '.$this->l('Settings').'
				'.($ps_version < 1.6 ? '</legend>' : '</h3>' ).'
			<table border="0" '.($ps_version < 1.6 ? 'width="750"' : '' ).' >
			<tr>
				<td align="left">
					'.$this->l('API Key').':
 					
					
					<span  class="info_tooltip" title=" <img src=\''.$this->_path.'img/apikey.jpg\' width=400  border=\'0\' /> "> </span>
					
				</td>
				<td align="left" '.($ps_version >= 1.6 ? '' : ' ' ).'>
					&nbsp;<input type="textbox" name="ov_key" value="'.Tools::getValue('ov_key', $this->_ov_key).'" '.($ps_version >= 1.6 ? 'size="100%"' : 'size="100%"' ).'  />

				</td>
			</tr>
			<tr>
				<td height="6"></td>
			</tr>
			<tr>
				<td align="left">
					'.$this->l('Cache Expiration').':
 					
					
					<span  class="info_tooltip" title="'.$this->l('IP Address location information will be retrieved again every X days').'"> </span>
					
				</td>
				<td align="left">
					&nbsp;<input type="textbox" name="ov_cache" value="'.Tools::getValue('ov_cache', $this->_ov_cache).'" size="4" /> '.$this->l('Days').'
				</td>
			</tr>
			<tr>
				<td height="6"></td>
			</tr>
			<tr>
				<td colspan="6" align="center">
					<input type="submit" value="'.$this->l('   Update   ').'" name="submitChanges" '.($ps_version >= 1.6 ? 'class="btn btn-default"' : 'class="button" ' ).' />
				</td>
			</tr>
			</table>
			'.($ps_version < 1.6 ? '</fieldset>' : '</div>' ).'
		</form>
			<script type="text/javascript">
				$(document).ready(function () {
					$(".hint_img").live({
						mouseenter:
						   function()  {
							$(this).siblings(".hint").show();
						   },
						mouseleave:
						   function() {
							$(this).siblings(".hint").stop().hide();
						   }
					});
				});
			</script>
		';
		$this->_html .= ($ps_version == 1.5?'</div>':'');
	}
	
	private function _postProcess()
	{
		if (Tools::isSubmit('submitChanges'))
		{
			if (!Configuration::updateValue('OV_KEY', Tools::getValue('ov_key'))
				|| !Configuration::updateValue('OV_CACHE', (int)Tools::getValue('ov_cache')))
				$this->_html .= '<div class="'.($this->getPSV() >= 1.6?'module_error alert alert-danger"':'alert error" style="background-color:#ece400"').'">'.$this->l('Cannot update settings').'</div>';
			else
				$this->_html .= '<div class="'.($this->getPSV() >= 1.6?'module_confirmation conf confirm alert alert-success"':'conf confirm"><img src="../img/admin/ok.gif" alt="'.$this->l('Confirmation').'" /').'>'.$this->l('Settings updated').'</div>';
			$this->_refreshProperties();
		}
	}
	
	public function getIPInfo($ip)
	{
		$psv  = $this->getPSV();
		$update = false;
		$ip_info = Db::getInstance()->getRow("SELECT * FROM  `"._DB_PREFIX_."oav_ip_info` WHERE ip = '$ip'");
		if ($ip_info)
		{
			$update = true;
			if ($ip_info['lastdate'] > time() - (86400 * $this->_ov_cache))
				return unserialize($ip_info['info']);
		}
		$url = 'http://api.ipinfodb.com/v3/ip-city/?format=xml&key='.$this->_ov_key.'&ip='.$ip;
		$str = @file_get_contents($url);
		if ($str == '' && function_exists('curl_init'))
		{
			$ch = curl_init();
			curl_setopt ($ch, CURLOPT_URL, $url);
			curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, 5);
			curl_setopt ($ch, CURLOPT_RETURNTRANSFER, true);
			$str = curl_exec($ch);
		}
		$ip_info = $this->xml2array(simplexml_load_string($str));
		if ($update)
			$query = "UPDATE `"._DB_PREFIX_."oav_ip_info` SET info = '".($psv >= 1.5?Db::getInstance()->_escape(serialize($ip_info)):mysql_real_escape_string(serialize($ip_info)))."', lastdate = '".time()."' WHERE ip = '$ip'";
		else
			$query = "INSERT INTO `"._DB_PREFIX_."oav_ip_info` values ('$ip', '".($psv >= 1.5?Db::getInstance()->_escape(serialize($ip_info)):mysql_real_escape_string(serialize($ip_info)))."', '".time()."')";
		Db::getInstance()->execute($query);
		return $ip_info;
		
	}
	
	private function xml2array( $xmlObject, $out = array () )
	{
		foreach ( (array) $xmlObject as $index => $node )
			$out[$index] = ( is_object ( $node ) ) ? $this->xml2array ( $node ) : $node;
		return $out;
	}	
	
	public function hookCart($params)
	{
		$cookie = $this->context->cookie;
		if (!Validate::isLoadedObject($params['cart']))
			return;
		if (isset($cookie->orderiplog) && $params['cart']->id == $cookie->orderiplog)
			return;
		$query = 'INSERT IGNORE INTO `'._DB_PREFIX_.'oav_order_ip_log` VALUES('.$params['cart']->id.',"'.$_SERVER['REMOTE_ADDR'].'")';
		Db::getInstance()->Execute(trim($query));
	}

	public function hookAdminOrder()
	{
		if ($this->_ov_key == '')
			return;
		$smarty = $this->context->smarty;
		$cookie = $this->context->cookie;
		$order_info = array();
		$order = new Order(Tools::getValue('id_order'));
		$ip = Db::getInstance()->getValue("SELECT ip FROM  `"._DB_PREFIX_."oav_order_ip_log` WHERE id_cart = '" . ((int) $order->id_cart) . "'");
		if ($ip != '')
			$order_info = $this->getIPInfo($ip);
			

		if ($order_info['statusCode'] == 'ERROR')
			$order_info = null;
		
		$smarty->assign(array('oav_info'=>$order_info, 'ps_version' => $this->getPSV()));
		return $this->display(__FILE__, 'views/templates/backend/adminOrder.tpl');
	}
}
?>